﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp2
{
    class Program
    {
        static void Main(string[] args)
        {
            Program pg = new Program();

            pg.CallAsyncVoid();

            pg.CallAsyncTask();

            pg.CallAsyncTaskAwait();
        }

        private async void AsyncVoid()
        {
            throw new InvalidOperationException();
        }

        public void CallAsyncVoid()
        {
            try
            {
                AsyncVoid();
            }
            catch (Exception e)
            {
                // 이곳의 코드는 절대 실행되지 않음.
                Console.WriteLine(e.ToString());
                throw;
            }
        }

        private async Task AsyncTask()
        {
            throw new InvalidOperationException();
        }

        public void CallAsyncTask()
        {
            try
            {
                AsyncTask();
            }
            catch (Exception e)
            {
                // 이곳의 코드는 절대 실행되지 않음.
                Console.WriteLine(e.ToString());
                throw;
            }
        }

        public async void CallAsyncTaskAwait()
        {
            try
            {
                await AsyncTask();
            }
            catch (Exception e)
            {
                // 이곳의 코드는 상태 머신을 갖는 별도의 클래스에 옮겨져 실행됨.
                Console.WriteLine(e.ToString());
                throw;
            }
        }
    }
}
